<template>

  <div
    v-loading="loading"
    class="scrollable"
    id="edit_cvtemplate"
    ref="edit_cvtemplate"
  >

    <div class="page-header">
      <h1>CV Template Edit</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
        <el-breadcrumb-item :to="{ path: '/cvtemplate' }">CV Template</el-breadcrumb-item>
        <el-breadcrumb-item>Edit</el-breadcrumb-item>
      </el-breadcrumb>
      <div
        class="btn-right"
        style="z-index:9;position:relative;"
      >
        <el-button
          v-if="isVisibleTopBtn"
          :disabled="isDisable"
          icon="mdi mdi-content-save-outline"
          type="success"
          @click="dialogvisible=true"
          class="m-20"
        > Preview</el-button>
        <el-button
          v-if="isVisibleTopBtn"
          :disabled="isDisable"
          icon="mdi mdi-content-save-outline"
          type="primary"
          @click="save"
          class="m-20"
        > Save changes</el-button>
      </div>

    </div>
    <el-tabs v-model="activeName">
      <el-tab-pane
        label="HTML"
        name="html"
      >

        <codemirror
          v-if="html"
          :options="cmOption"
          v-model="value"
        ></codemirror>
      </el-tab-pane>
      <el-tab-pane
        v-loading="tabLoading"
        label="CSS"
        name="css"
      >

        <codemirror
          v-if="css"
          :options="cmOption"
          v-model="textarea"
        ></codemirror>
      </el-tab-pane>

    </el-tabs>

    <div class="btn-right">
      <el-button
        v-if="isVisibleBottomBtn"
        :disabled="isDisable"
        icon="mdi mdi-content-save-outline"
        type="success"
        @click="dialogvisible=true"
        class="m-20"
      > Preview</el-button>
      <el-button
        v-if="isVisibleBottomBtn"
        :disabled="isDisable"
        icon="mdi mdi-content-save-outline"
        type="primary"
        @click="save"
        class="m-20"
      > Save changes</el-button>

    </div>
    <br />
    <TemplateCV
      :dialogvisible.sync="dialogvisible"
      :value.sync="value"
      :textarea.sync="textarea"
    ></TemplateCV>
  </div>
</template>

<script>

// import VueFroala from 'vue-froala-wysiwyg';
// Include code view

import {
  document as documentApi
} from '~/services/apis/index';
import 'codemirror/lib/codemirror.js';
import 'codemirror/mode/htmlmixed/htmlmixed.js';
import 'codemirror/addon/display/autorefresh.js';
import "codemirror/lib/codemirror.css";
import { codemirror } from 'vue-codemirror'
import beautify_html from 'js-beautify';
// require styles
import 'codemirror/lib/codemirror.css'
// import codeMirror from 'codemirror';
import TemplateCV from '~/components/dialogs/Template';
export default {
  name: 'edit_cvtemplate',
  components: {
    codemirror,
    TemplateCV
  },
  data () {
    return {      dialogvisible: false,
      cmOption: {
        styleActiveLine: true,
        indentWithTabs: true,
        lineNumbers: true,
        lineWrapping: true,
        mode: 'text/html',
        tabMode: 'indent',
        tabSize: 2,
        matchBrackets: true,
        autoRefresh: true,
        autofocus: true,
      },
      beautifyOptions: {
        end_with_newline: false,
        indent_inner_html: true,
        brace_style: 'expand',
        indent_char: ' ',
        indent_size: 4,
        wrap_line_length: 0
      },
      config: {
        toolbarSticky: false,
        height: '100%',
        placeholderText: 'Edit Your Content Here!',
        pluginsEnabled: ['codeBeautifier', 'codeView', 'inlineClass', 'codeMirror'],
        toolbarButtons: ['html'],
        // Enable code view
        // codeMirror: codeMirror,
        // Config codeMirrorOptions
        codeMirrorOptions: {
          styleActiveLine: true,
          indentWithTabs: true,
          lineNumbers: true,
          lineWrapping: true,
          mode: 'text/html',
          tabMode: 'indent',
          tabSize: 2,
          matchBrackets: true,
        },
        // Config codeBeautifier options
        codeBeautifierOptions: {
          end_with_newline: false,
          indent_inner_html: true,
          //   extra_liners: "['p', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'blockquote', 'pre', 'ul', 'ol', 'table', 'dl']",
          brace_style: 'expand',
          indent_char: ' ',
          indent_size: 4,
          wrap_line_length: 0
        },

        // set useClasses=true to use ExternalCSS(otherwise CSS will be converted to inline style. )
        useClasses: true,
        // fullPage: include HTML, body, head tags
        fullPage: true,
        // Remove tags but allowed content
        htmlAllowedTags: ['.*'],
        //Default remove ['script', 'style', 'base']
        htmlRemoveTags: [''],
        // Allowed attibute of HTML tags
        htmlAllowedAttrs: ['.*'],
        allowedContent: true,
        iframeStyle: this.textarea,
        // removed watermark
        attribution: false,
      },
      value: '',
      id: "",
      tabLoading: true,
      loading: true,
      editorLoading: false,
      activeName: 'html',
      textarea: '',
      content: '',
      isDisable: false,
      isVisibleTopBtn: true,
      isVisibleBottomBtn: false,
      html: true,
      css: true,
    }
  },
  watch: {
  },
  methods: {

    save () {
      this.editorLoading = true;
      if (!this.value || !this.textarea) {
        this.$notify({
          title: "Error",
          message: "Update  failed!",
          type: "error"
        });
        this.getCVTemplate();
        this.editorLoading = false;
        return
      }

      const stringifyHTML = this.value
      const stringifyCSS = this.textarea
      //   const template = stringifyCSS + stringifyHTML
      const template = stringifyHTML.replace(/<style>(.|\n)*?<\/style>/g, stringifyCSS);
      //eslint-disable-next-line
      //   console.log('template :', template);
      this.content = template
      const data = {
        content: template
      }
      const idDocument = 3;
      documentApi.saveDocument(idDocument, data).then(res => {

        this.$notify({
          title: "Success",
          message: "Update successfully!!!",
          type: "success"
        })
        this.$router.push({ path: '/cvtemplate' });
      }).catch(err => {
        this.$notify({
          title: "Error",
          message: "Update failed!",
          type: "error"
        });
        this.getCVTemplate();
        this.editorLoading = false;
      });

    },
    getCVTemplate () {
      this.loading = true
      const idDocument = 3;
      documentApi.getDocument(idDocument).then(res => {

        let json = res.data.data.content.replace(/\\n/g, '');
        this.value = json.replace(/\\/g, '');

        const regex = (/<style>(.|\n)*?<\/style>/g);
        // const regex =
        const styleCSS = this.value.match(regex);


        this.textarea = styleCSS ? styleCSS.toString() : '';
        this.textarea = beautify_html.css_beautify(this.textarea)
        this.config.iframeStyle = this.textarea
        this.value = this.value.replace(regex, '<style> </style>');
        this.value = beautify_html.html_beautify(this.value);

        this.loading = false
      }).catch(err => {
        //eslint-disable-next-line
        console.log('err :', err);
        this.loading = false
      })
    },

    handlePreview () {
      this.editorLoading = true
      this.isDisable = true
      const stringifyHTML = this.value
      const stringifyCSS = this.textarea
      //   const template = stringifyCSS + stringifyHTML
      const template = stringifyHTML.replace(/<style>(.|\n)*?<\/style>/g, stringifyCSS);

      this.content = template
      const data = {
        html: template
      }
      documentApi.getPreviewSeekerProfile(data).then(res => {

        let json = res.data.data[0].replace(/\\n/g, '');
        this.value = json.replace(/\\/g, '');


        const styleCSS = this.value.match(/<style>(.|\n)*?<\/style>/g);


        this.textarea = styleCSS ? styleCSS.toString() : '';
        this.config.iframeStyle = this.textarea

        this.$notify({
          title: "Success",
          message: "Preview successfully!",
          type: "success"
        });
        this.editorLoading = false
        setTimeout(() => {
          this.isDisable = false
        }, 1000)

      }).catch(error => {
        this.$notify({
          title: "Error",
          message: "Preview failed!",
          type: "error"
        });
        this.editorLoading = false
        this.isDisable = false
      })
    },
    handleScroll (e) {
      if (e.target.scrollHeight - e.target.scrollTop === e.target.scrollHeight) {
        this.isVisibleTopBtn = true
      }
      if ((e.target.scrollHeight - e.target.scrollTop) - e.target.clientHeight <= 200) {
        this.isVisibleBottomBtn = true
        this.isVisibleTopBtn = false
      } else {
        this.isVisibleBottomBtn = false
        this.isVisibleTopBtn = true
      }
    },

  },
  mounted () {

    document.getElementById('edit_cvtemplate').addEventListener('scroll', this.handleScroll);

  },
  created () {
    this.getCVTemplate();
  },
  destroyed () {
    // document.getElementById('edit_cvtemplate').removeEventListener('scroll', this.handleScroll)
  },

}
</script>
<style>
.fr-wrapper div:first-child a {
  display: none !important;
}
body.el-tabs__content {
  overflow-y: scroll !important;
}
.fr-wrapper {
  overflow-y: scroll !important;
}

.CodeMirror {
  height: 100%;
}
/* .el-tabs__nav-wrap::after {
  display: none;
} */
</style>


